/******************************************************************************
*
*  Program Number 5763-CD1 (C) Copyright IBM Corp. 1992, 1994.
*  All rights reserved.
*
******************************************************************************/

/* Turn off trace */
Trace 'O'

/* Echo DOS commands on the screen */
'@echo on'

CODE_V2Rx_Installed = 0
Migrate = ''

/* Access REXX utility function SysIni */
Result = RxFuncQuery('SysIni')
If Result Then Result = RxFuncAdd('SysIni', 'RexxUtil', 'SysIni')

/* SysIni function is correctly loaded */
If Result = 0 Then Do

   CODE_INI_file = ''

   /* Find the CODE INI file from OS2.INI */
   CODE_INI_path = Remove0x(SysIni(, 'CODEINSTALL', 'INSTPATH'))
   If CODE_INI_path <> "ERROR:" & CODE_INI_path <> '' Then Do
      /* Get rid of trailing '\', just in case */
      If Right(CODE_INI_path, 1) = '\' Then
         CODE_INI_path = Left(CODE_INI_path, Length(CODE_INI_path)-1)

      /* Check for EVFINSTS.INI in the specified directory */
      CODE_INI_file = CODE_INI_path||'\EVFINSTS.INI'
      CODE_INI_file = Stream(CODE_INI_file, 'c', 'query exists')

      /* Now, check for EVFCCODE.INI as well */
      If CODE_INI_file <> "ERROR:" & CODE_INI_path <> '' Then Do
         CODE_INI_file = CODE_INI_path||'\EVFCCODE.INI'
         CODE_INI_file = Stream(CODE_INI_file, 'c', 'query exists')
         End
      End

   /* If not found yet, try another application/key in OS2.INI */
   If CODE_INI_file = 'ERROR:' | CODE_INI_file = '' Then Do
      CODE_INI_file = Remove0x(SysIni(, 'EVF_INSTALL', 'ProfileFilename'))
      If CODE_INI_file <> "ERROR:" & CODE_INI_file <> '' Then Do
         CODE_INI_path = Filespec('drive', CODE_INI_file)||Filespec('path', CODE_INI_file)

         /* Get rid of trailing '\', just in case */
         If Right(CODE_INI_path, 1) = '\' Then
            CODE_INI_path = Left(CODE_INI_path, Length(CODE_INI_path)-1)

         /* Check for EVFINSTS.INI in the specified directory */
         CODE_INI_file = CODE_INI_path||'\EVFINSTS.INI'
         CODE_INI_file = Stream(CODE_INI_file, 'c', 'query exists')

         /* Now, check for EVFCCODE.INI as well */
         If CODE_INI_file <> "ERROR:" & CODE_INI_path <> '' Then Do
            CODE_INI_file = CODE_INI_path||'\EVFCCODE.INI'
            CODE_INI_file = Stream(CODE_INI_file, 'c', 'query exists')
            End
         End
      End

   /* If both files found, then CODE V2Rx is installed */
   If CODE_INI_file <> 'ERROR:' & CODE_INI_file <> '' Then
      CODE_V2Rx_Installed = 1

   bootdrive = filespec('drive', value('USER_INI',, 'OS2ENVIRONMENT'))
   epfisini = stream(bootdrive'\OS2\SYSTEM\EPFIS.INI', 'c', 'query exists')
   if epfisini <> '' then do

      if CODE_INI_path = 'ERROR:' | CODE_INI_path = '' then
         CODE_INI_path = Remove0x(SysIni(epfisini, 'EPFINST_ADTS CS/400_5763-CL1_0600', 'FilePath'))
      if CODE_INI_path <> 'ERROR:' & CODE_INI_path <> '' then
         '@if exist' CODE_INI_path'\*.pkg @attrib -r' CODE_INI_path'\*.pkg'

      lpexdir = Remove0x(SysIni(epfisini, 'EPFINST_LPEX_0000-000_0000', 'FilePath'))
      if lpexdir <> 'ERROR:' & lpexdir <> '' then
         '@if exist' lpexdir'\*.pkg @attrib -r' lpexdir'\*.pkg'

      ibmwfdir = Remove0x(SysIni(epfisini, 'EPFINST_WorkFrame/2_5622-016_0000', 'FilePath'))
      if ibmwfdir <> 'ERROR:' & ibmwfdir <> '' then
         '@if exist' ibmwfdir'\*.pkg @attrib -r' ibmwfdir'\*.pkg'
      end

   /* Now de-register the function */
   call RxFuncDrop 'SysIni'

   End

/* Parse parameters */
Parse Upper Arg Parms

/* Defaults assumed for this program.                    */
Action = 'I'              /* Install                     */

Help = 0                  /* Do not invoke Help          */

/* Loop through all parameters */
i = 1
Other_Parameters = ''
Do until i > words(Parms)

   Parm = word(Parms, i)
   Next_Parm = word(Parms, i + 1)

   Select

      When (Parm = '/H' | Parm = '-H' | Parm = '/?' | Parm = '-?' | Parm = '?') Then Do
         Help = 1
         End
      When (Parm = '/A' | Parm = '-A') Then Do
         Action = Next_Parm
         /* Now skip the next parm */
         i = i + 1
         End
      Otherwise Other_Parameters = Other_Parameters||' '||Parm
      End
   /* Process next parameter */
   i = i + 1
   End

/* If invalid action specified, override to I (Install) */
If (Action <> 'I' & Action <> 'U' & Action <> 'D') Then Action = 'I'

/* If CODE V2Rx is installed, change 'Update' to 'Install' */
If (CODE_V2Rx_Installed & Action = 'U') Then Do
   Action = 'I'
   Migrate = '/MIGRATE'
   End

Parse Upper Source . . CMD_filespec .
Parse Var CMD_filespec CMD_path'CODEINST.CMD' .

/* For QCODE2\CODEINST, check if QVDEW is installed */
if pos('QCODE2', CMD_path) <> 0 then do
   t = pos('QCODE2', CMD_path)
   QVDEW_path = left(CMD_path, t-1)'QVDEW'substr(CMD_path, t+length('QCODE2'))

   t = stream(QVDEW_path'CODEINST.CMD', 'c', 'query exists')
   if t <> '' & stream(QVDEW_path'MRM\BIN\EVFIINST.EXE', 'c', 'query exists') <> '' then
      EVFIINST = QVDEW_path'MRM\BIN\EVFIINST'
   else
      EVFIINST = CMD_path'MRM\BIN\EVFIINST'
   end
/* Neither QCODE2 nor QVDEW */
else if pos('QVDEW', CMD_path) = 0 then do
   say 'Must install from QCODE2 or QVDEW folder.'
   exit 1
   end
/* invoke QVDEW\BIN\EVFIINST directly */
else
   EVFIINST = CMD_path'MRM\BIN\EVFIINST'

/* If Help, ignore all other parameters */
if (Help) Then Do
   EVFIINST '/H' Other_Parameters
   Exit
   End

/* Invoke EVFIINST with parameters as specified.                       */
EVFIINST '/A' Action Other_Parameters

if CODE_INI_path <> 'ERROR:' & CODE_INI_path <> '' then
   '@if exist' CODE_INI_path'\*.pkg @attrib -r' CODE_INI_path'\*.pkg /s'

if lpexdir <> 'ERROR:' & lpexdir <> '' then
   '@if exist' lpexdir'\*.pkg @attrib -r' lpexdir'\*.pkg /s'

if ibmwfdir <> 'ERROR:' & ibmwfdir <> '' then
   '@if exist' ibmwfdir'\*.pkg @attrib -r' ibmwfdir'\*.pkg /s'

Exit


/* Get rid of the null termination that C uses for a string     */
/* i.e. extract everything up to, but not including, the '0'x.  */
Remove0x:

Arg String

End_String = Pos('0'x, String)
If End_String = 0 Then
   End_String = Pos('0d0a'x, String)
If End_String > 0 Then
   String = Left(String, End_String - 1)

return String
