/******************************************************************************/
/* FVDDEBUG.CMD                                                               */
/*                                                                            */
/*            5763-VR1 COPYRIGHT IBM CORP. 1994.                              */
/*            LICENSED MATERIAL - PROGRAM PROPERTY OF IBM                     */
/*                                                                            */
/*      Description: VRPG Client/2 REXX program to be used by end-users to    */
/*                   turn off the debug trace.                                */
/*                                                                            */
/******************************************************************************/

/* Set the name of the trace file */
tracefile = 'FVDDEBUG.TRC'

/* Get the command line parameters */
Parse Arg parameters

/* call the utility REXX program to turn the Debug DLLs on */
'Call FVDDBF /ON'

If Rc = 0 Then Do
   /* execute the parameters as a command, redirecting STDERR to the trace file */
   parameters '2>' tracefile

   /* now that we're done, tell the user about the tracefile and FVDDBOFF */
   Say
   Say 'Trace output can be found in the file' tracefile || '.'
   Say 'To resume normal use, end the debug mode using the command FVDDBOFF.'

   Exit 0
End
Else Do
   /* Exit with the non-zero return code from FVDDBF */
   Exit Rc
End
