/*-------------------------------------------------------------------------*/
/* File name: fvdiph2.cmd                                                  */
/*                                                                         */
/*            5763-VR1 COPYRIGHT IBM CORP. 1994.                           */
/*            LICENSED MATERIAL - PROGRAM PROPERTY OF IBM                  */
/*                                                                         */
/* Description: handle vrpg install after the wf is successfully installed */
/*              - reset the som flag in ini during update                  */
/*              - create designer icon                                     */
/*              - create action profile                                    */
/*              - create sample application                                */
/*                                                                         */
/*-------------------------------------------------------------------------*/
/* trace '?a' */
trace 'o'

parse arg bootdrive codedir wfdir action profile_folder sample_folder

call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

/* check if wf is successfully installed */
if wfdir = 'ERROR:' | wfdir = '' then do
  exit
end

/* Check if phase 2 is successfully executed */
phase = Remove0x(SysIni( , 'IBMWFV2', 'PHASE'))

if phase <> 2 then do
  exit
end

/* reset som flag in the ini during update */
if action = 'UPDATE' then do
   '@'codedir'\BIN\FVDIUINI'
end

/* create designer icon and action profile */
'@'codedir'\BIN\FVDIACPR' action profile_folder

/* create sample applications */
if sample_folder <> '' then
  '@'codedir'\BIN\FVDISAMP' action sample_folder codedir

exit
/*--------------------------------------------------------------*/
/* Get rid of the null termination that C uses for a string     */
/* i.e. extract everything up to, but not including, the '0'x.  */
/* Also removes CR/LF                                           */
/*--------------------------------------------------------------*/
Remove0x:
Parse Arg String

End_String = Pos('0'x, String)
If End_String = 0 Then
   End_String = Pos('0d0a'x, String)
If End_String > 0 Then
   String = Left(String, End_String - 1)

return String
