/*************************************************************************
*
*  Copyright (C) 1993 IBM Corporation
*
*      DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
*      sample code created by IBM Corporation. This sample code is not
*      part of any standard or IBM product and is provided to you solely
*      for  the purpose of assisting you in the development of your
*      applications.  The code is provided "AS IS", without
*      warranty of any kind.  IBM shall not be liable for any damages
*      arising out of your use of the sample code, even if they have been
*      advised of the possibility of such damages.
*
************************************************************************/
#include <iostream.h>

#include "calc_cls.h"

CALCULATOR::CALCULATOR(unsigned int NewNumberOfFunctions = 0)
{
        for (int i = 0; i <= 7; i++)
                Reg[i].SetRegister( 0.0, 0);

        for (i = 8; i <= 15; i++)
                Reg[i].SetRegister( 0.0, 1);


        NumberOfFunctions = NewNumberOfFunctions;

        if (NumberOfFunctions <= 8)
                SizeOfFunctionBuffer = 8;
        else
                SizeOfFunctionBuffer = NumberOfFunctions;

        AFunc = new FUNCTION[SizeOfFunctionBuffer];
}


int CALCULATOR::ProcessFunction(char * InFunc)
{
        int RC = 0;

        for (int i = 0; i < NumberOfFunctions; i++)
        {
                if ( strcmp( InFunc, AFunc[i].GetText()) == 0 )
                {
                        RC = AFunc[i].DoIt();
                        return RC;
                }
        }

        cout << "Function not defined." << endl;

        return ERROR;
}

void CALCULATOR::ShowHelp(void)
{
        cout << "\nCommand Summary:" << flush;

        for (int i = 0; i < NumberOfFunctions; i++)
        {
                cout << "\n" << AFunc[i].GetText() << flush;
                cout << "\t" << AFunc[i].GetDescription() << flush;
        }
        cout << "\n^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^\n" << flush;
}

void CALCULATOR::CopyBuffer(FUNCTION *AFunc, FUNCTION *NewBuffer)
{
        for( unsigned int i =0; i < SizeOfFunctionBuffer; i ++)
        {
                NewBuffer[i] = AFunc[i];
        }
}


/********************************************************/
