/*************************************************************************
*
*  Copyright (C) 1993 IBM Corporation
*
*      DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
*      sample code created by IBM Corporation. This sample code is not
*      part of any standard or IBM product and is provided to you solely
*      for  the purpose of assisting you in the development of your
*      applications.  The code is provided "AS IS", without
*      warranty of any kind.  IBM shall not be liable for any damages
*      arising out of your use of the sample code, even if they have been
*      advised of the possibility of such damages.
*
************************************************************************/

#include <string.h>

#include "calc.h"

/********************************************************************\
*  The DummyFunc function is used only as a placeholder when the
*  tags are constructed.
\********************************************************************/
/*
int DummyFunc(void);
int DummyFunc()
{
        return 0;
}
*/

//######################################################
class FUNCTION
{
        char Text[32];
        char Description[128];
        int (*Function)(void);

public:
        FUNCTION() {}   // This constructor is used when initializing arrarys
                        // of functions.

        // The following constructor is used when initializing individual functions.
        FUNCTION(char *NewText, char *NewDescription,
                        int (*NewFunction)(void))
        {
                Set( NewText, NewDescription, NewFunction);
        }

        int Set(char *NewText, char *NewDescription, int (*NewFunction)(void))
        {
                strcpy(Text, NewText);
                strcpy(Description, NewDescription);
                Function = NewFunction;
                return NO_ERROR;
        }

        char * GetText(void)
        {
                return Text;
        }

        char * GetDescription(void)
        {
                return Description;
        }

        int DoIt(void)
        {
                int RC=0;

                RC = (*Function)();

                return RC;
        }
};

/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

class REGISTER
{
        double Value;
        int ReadOnlyFlag;

public:
        REGISTER(double NewValue = 0.0, int NewReadOnlyFlag = 0)
        {
                SetRegister( NewValue, NewReadOnlyFlag);
        }

        void SetRegister(double NewValue = 0.0, int NewReadOnlyFlag = 0)
        {
                Value = NewValue;
                ReadOnlyFlag = NewReadOnlyFlag;
        }

        void Store(double NewValue)
        {
                Value = NewValue;
        }

        double GetValue()
        {
                return Value;
        }

        int IsReadOnly(void)
        {
                return ReadOnlyFlag;
        }
};

/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

class CALCULATOR
{
        unsigned int NumberOfFunctions;
        unsigned int SizeOfFunctionBuffer;

//      BUFFER *FunctionBuffer;

//FUNCTION AFunc;


        FUNCTION *AFunc;

//      REGISTER *Reg = new REGISTER[16];

public:

        REGISTER Reg[16];

        CALCULATOR(unsigned int);

/*
        ~CALCULATOR()
        {
                delete[SizeOfFunctionBuffer] AFunc;
                delete[16] Reg;
        }
*/
        int IncreaseBuffer(unsigned int Increase = 8)
        {
                FUNCTION *NewBuffer = new FUNCTION[SizeOfFunctionBuffer + Increase];

                CopyBuffer(AFunc, NewBuffer);

                delete[] AFunc;

                AFunc = NewBuffer;

                SizeOfFunctionBuffer += Increase;

                return NO_ERROR;
        }

        int AddFunction(char *NewText, char *NewDescription, int (*NewFunction)(void))
        {
                if (NumberOfFunctions == SizeOfFunctionBuffer)
                        IncreaseBuffer();

                AFunc[NumberOfFunctions].Set( NewText, NewDescription, NewFunction);

                NumberOfFunctions++;

                return NO_ERROR;
        }

        void CopyBuffer(FUNCTION *, FUNCTION *);

        int ProcessFunction(char *);

        void ShowHelp(void);
};
