/***************************************************************************/
/* The following C program is written to be called from the RPG program    */
/* as a SPECIAL file device. This program will do the Local I/O operations */
/* Namely, open, read, write, and close.                                   */
/***************************************************************************/
#include <stdio.h>

extern void IO ( char*option,char*status,char *error,char*area, char*parm)

{
#define REC_SIZE 60

#define NORMAL_STATUS '0'
#define EOF_STATUS    '1'
#define ERROR_STATUS  '2'

#define OPEN_ERROR    11111
#define READ_ERROR    88888
#define OPTION_ERROR  99999

   static FILE *fp ;
   int    radix = 10 ;
   int    a     = 0 ;
   char   temp[6] ;

   switch  (option[0]) 
    {
     /*********************************************************/
     /* Use the fopen function call to open the local data    */
     /* file. In this case the local file called database.dat */
     /*********************************************************/
     case 'O' :                      
       if ((fp=fopen("database.dat", "r+")) == NULL) 
         {
            a = OPEN_ERROR ;          /************************/
            _itoa( a, temp, radix ) ; /* Incase of error do   */
            memcpy( error, temp, 5 ) ;/* what you want here   */
            status[0] = ERROR_STATUS ;/************************/
         }
       else 
         {
            status[0] = NORMAL_STATUS ;
         }

       break ;

     /********************************************************/
     /* Use the fclose C function to close the file. You may */
     /* want to add code to handle error conditions.         */
     /********************************************************/
     case 'C' :
       fclose(fp);
       status[0] = NORMAL_STATUS ;
       break ;

     case 'R' :                      /* Read a record        */
       fread(area, 1, REC_SIZE, fp) ;
       if (feof(fp)) 
         {
            status[0] = EOF_STATUS ;
         }
       else if (ferror(fp))         
         {
            a = READ_ERROR ;
            _itoa( a, temp, radix ) ;
            memcpy( error, temp, 5 ) ;
            status[0] = ERROR_STATUS ;
         }
       else 
         {
            status[0] = NORMAL_STATUS ;
         }
       break ;

    case 'W' :
          fwrite(area, 1, REC_SIZE, fp) ;

    default :
          a = OPTION_ERROR ;         
          _itoa( a, temp, radix ) ;  
          memcpy( error, temp, 5 ) ;
          status[0] = ERROR_STATUS ;
          break ;
  }

  return ;
}
