/***********************************************************
*                                                          *
*  LPEXAPI.H:  Include file to be used for External C      *
*               LPEX commands                              *
*                                                          *
************************************************************
*                                                          *
*          (C) Copyright IBM Corporation 1993              *
*                                                          *
***********************************************************/
 
/*-----------------------------------------------------------------*/
#include "lpexcpat.h"
 
#define _cinit
#define _cterm
/*-----------------------------------------------------------------*/
 
#define MAXLEN  2500                 /* Maximum element size */
#define MAXQUERY 2800             /* Maximum length for query result */
 
#define uchr unsigned char           /* LPEX uses unsigned char throughout */
#ifndef LP_COMMAND
#if defined( WM_USER )
#define LP_COMMAND     (WM_USER + 4)   // Execute an LPEX command. mp2 is MPFROM2SHORT( a, b )
#endif
#define LP_COMMAND_EXTERNAL ((short)0) // where "a" can be either LP_COMMAND_INTERNAL or
#define LP_COMMAND_INTERNAL ((short)1) // LP_COMMAND_EXTERNAL, and "b" can be either
#define LP_COMMAND_WINDOWED ((short)0) // LP_COMMAND_WINDOWED or LP_COMMAND_CURRENT.
#define LP_COMMAND_CURRENT  ((short)1)
#endif
 
 int    LpexEntry(uchr *);                      /* Command entry point */
 int    LpexExit(uchr *);                       /* Command unlink exit point */
 int    LpexCommand(uchr *);                    /* run an LPEX command */
 int    LpexCall(uchr *, uchr *);               /* call an LPEX function */
 uchr * LpexQuery(uchr *, uchr *);              /* Query an LPEX item */
/* all storage allocation/freeing to be done by LPEX */
 uchr * LpexAlloc(int);                         /* allocate LPEX storage */
 int    LpexFree(uchr *);                       /* free LPEX allocated storage */
 
#define LpexMsg(a)                  LpexCall("msg",a)
 
/* the following functions support the user word */
 int     LpexQueryUserLink(long int scope,void **pObjectPtr);
 int     LpexSetUserLink(long int scope, void *object);
 int     LpexFindUserLink(long int scope,void *object);
 
 /* current valid values of scope */
  #define LPEX_DOCUMENT 1
  #define LPEX_VIEW     2
  #define LPEX_ELEMENT  3
 
/* the following extend the fonts recognised by GML */
 int     LpexQueryGMLFonts(uchr *);     /* query special GML fonts */
 int     LpexAddGMLFonts(uchr *);       /* add to special GML fonts */
 
/* the following are fast path entry to some common functions */
 int     LpexNext(uchr *);              /* NEXT          */
 int     LpexPrev(uchr *);              /* PREV          */
 int     LpexInsert(uchr *);            /* INSERT text   */
 int     LpexQueryRawText(uchr *);      /* query RAWTEXT */
 int     LpexQueryText(uchr *);         /* query CONTENT */
 int     LpexSetText(uchr *);           /* set   CONTENT */
 int     LpexQueryFonts(uchr *);        /* query FONTS   */
 int     LpexSetFonts(uchr *);          /* set   FONTS   */
 int     LpexQueryCharModes(uchr *);    /* query MODES   */
 int     LpexQueryClass(unsigned long *);/* query CLASS   */
 int     LpexSetClass(unsigned long);   /* set   CLASS   */
 int     LpexQueryElementState(unsigned long *); /* query ELESTATE - defined states are */
   #define LPEX_ELE_VISIBLE   (0x80000000)      /* visible element */
   #define LPEX_ELE_SHOW      (0x40000000)      /* show element */
   #define LPEX_ELE_PROTECTED (0x20000000)      /* protected element */
