/******************************************************************************/
/*                                                                            */
/* COPYRIGHT: Copyright (C) International Business Machines Corp., 1994.      */
/*                                                                            */
/* DISCLAIMER OF WARRANTIES:                                                  */
/*   The following [enclosed] code is sample code created by IBM              */
/*   Corporation.  This sample code is not part of any standard IBM product   */
/*   and is provided to you solely for the purpose of assisting you in the    */
/*   development of your applications.  The code is provided "AS IS",         */
/*   without warranty of any kind.  IBM shall not be liable for any damages   */
/*   arising out of your use of the sample code, even if they have been       */
/*   advised of the possibility of such damages.                              */
/******************************************************************************/
/*************************************************************************
 * File Name    :  movie.c
 *************************************************************************/

#define  INCL_WIN                   /* required to use Win APIs.           */
#define  INCL_PM                    /* required to use PM APIs.            */
#define  INCL_WINHELP               /* required to use IPF.                */
#define  INCL_OS2MM                 /* required for MCI and MMIO headers   */
#define  INCL_MMIOOS2               /* required for MMVIDEOHEADER          */
#define  INCL_MMIO_CODEC            /* required for circular, secondary    */
#define  INCL_SW                    /* required for circular, secondary    */
                                    /* windows and graphic buttons         */
#define  INCL_WINSTDFILE            /* required for open file dlg          */
#define  INCL_WINSTDDLGS            /* required for open file dlg          */

#include <os2.h>
#include <os2me.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <sw.h>

/*
 * Procedure/Function Prototypes
 */
BOOL    PlayTheMovie( HWND hwnd, CHAR *filename );
BOOL    OpenTheDevice( HWND );
BOOL    SendString( HWND hwnd, PCHAR pcMCIString, USHORT usUserParm );
extern void PlayMovie ( char*filename);
extern void StopMovie ( void);

/*************** End of Procedure/Function Prototypes *************************/

  /*
  * Global Variables.
  */


CHAR   szReturn[CCHMAXPATH];           /* return value from mciSendString     */
HPOINTER  hptrWait, hptrArrow;  /* Pointer handles for use during long waits. */

/************************** End of Global Variables ***************************/


/******************************************************************************/
extern void PlayMovie ( char*filename)
{
   BOOL  frc;
   HWND  hwnd=0;
   LONG    lmciSendStringRC;            /* return code from SendString       */
   hptrArrow = WinQuerySysPointer ( HWND_DESKTOP, SPTR_ARROW, FALSE );
   hptrWait  = WinQuerySysPointer ( HWND_DESKTOP, SPTR_WAIT,  FALSE );
   OpenTheDevice ( hwnd );
   frc=PlayTheMovie(hwnd, filename);
   lmciSendStringRC = SendString( hwnd,"play movie wait", 0 );
   lmciSendStringRC = SendString( hwnd,"close movie wait", 0 );
   return;
}

extern void StopMovie ()
{
   LONG    lmciSendStringRC;            /* return code from SendString       */
   lmciSendStringRC = SendString( (HWND)NULL, "stop movie wait", 0 );
   return;
}

/******************************************************************************
 * Name         :  PlayTheMovie
 ******************************************************************************/
BOOL PlayTheMovie( HWND hwnd, CHAR *filename  )
{
   LONG    lmciSendStringRC;            /* return code from SendString       */
   BOOL  frc;
   CHAR szBuffer[128];   /* string command buffer          */


   /**********************************************************************/
   /* Change pointer to a waiting pointer first, since this might take a */
   /* couple of seconds.                                                 */
   /**********************************************************************/

   WinSetPointer( HWND_DESKTOP, hptrWait );

   sprintf( szBuffer, "load movie %s wait", filename);
   lmciSendStringRC = SendString(hwnd, szBuffer, 0);


   /******************************************************************/
   /* Now that we're done here, change the pointer back to the arrow.*/
   /******************************************************************/
   WinSetPointer ( HWND_DESKTOP, hptrArrow );

   return( TRUE );

}  /* end of PlayTheMovie */


/*************************************************************************
 * Name         :  OpenTheDevice
 ******************************************************************************/
BOOL OpenTheDevice( HWND hwnd)
{
   BOOL  frc;

   frc = SendString( hwnd,
                     "open digitalvideo alias movie wait",
                     0 );


}  /* end of OpenTheDevice */

/*************************************************************************
 * Name         :  SendString
 ******************************************************************************/
BOOL  SendString( HWND hwnd, PCHAR pcMCIString, USHORT usUserParm )
{
   LONG           lmciSendStringRC;    /* return value fromm mciSendString     */


   lmciSendStringRC =
       mciSendString( (PSZ)pcMCIString,
                      (PSZ)szReturn,
                      (USHORT)CCHMAXPATH,
                      (HWND)hwnd,
                      (USHORT)usUserParm );

   return( TRUE );
}

